unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, UTurtle;

type
  TForm1 = class(TForm)
    Turtle1: TTurtle;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Pythagoras(l,n:extended);
    procedure Button2Click(Sender: TObject);
    procedure Quadrat(l:extended);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
function laengegeg(l:extended):extended;
begin
  laengegeg:= sin(pi / 3) * l;
end;

function laengean(l:extended):extended;
begin
  laengean:= cos(pi / 3) * l;
end;

procedure TForm1.Quadrat(l:extended);
begin
    turtle1.Turn(-90);
    turtle1.Draw(l);
    turtle1.Turn(90);
    turtle1.Draw(l);
    turtle1.Turn(90);
    turtle1.Draw(l);
    turtle1.Turn(-60);
end;

procedure TForm1.Pythagoras(l,n:extended);
begin
  if n > 0 then
  begin
    Quadrat(l);
    Pythagoras(laengegeg(l), n - 1);
    turtle1.Turn(-90);
    turtle1.Move(laengegeg(l));
    Pythagoras(laengean(l), n - 1);
    turtle1.Turn(-90);
    turtle1.Move(laengean(l));
    turtle1.Turn(-120);
    turtle1.Draw(l);
    turtle1.Turn(90);
    turtle1.Draw(l);
    turtle1.Turn(-180);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  turtle1.MoveTo(425,270);
  turtle1.Turn(90);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
l, n: extended;
begin
  l:= StrToFloat(Edit1.Text);
  n:= StrToFloat(Edit2.Text);
  Pythagoras(l,n);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  turtle1.Clear;
  turtle1.MoveTo(425,270);
end;

end.
